/*
 * $QNXLicenseC:
 * Copyright 2007, 2008, QNX Software Systems. All Rights Reserved.
 *
 * You must obtain a written license from and pay applicable license fees to QNX
 * Software Systems before you may reproduce, modify or distribute this software,
 * or any work that includes all or part of this software.   Free development
 * licenses are available for evaluation and non-commercial purposes.  For more
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *
 * This file may contain contributions from others.  Please review this entire
 * file for other proprietary rights or license notices, as well as the QNX
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/
 * for other information.
 * $
 */

#include <errno.h>
#include <pthread.h>

int pthread_barrier_destroy(pthread_barrier_t *b) {
	int result = pthread_mutex_lock(& b->__lock);
	if (EOK == result) {
		int condres = pthread_cond_destroy(& b->__bcond);
		int mutexres = pthread_mutex_destroy(& b->__lock);
		result = (EOK != condres) ? condres : mutexres;
	}
	return result;
}

/* Only for binary compatibility with 2.0 programs */
#include <sync.h>

int (barrier_destroy)(barrier_t *b) {
	return pthread_barrier_destroy((pthread_barrier_t *)b);
}


__SRCVERSION("barrier_destroy.c $Rev: 213479 $");
